diff --git a/strongswan-5.2.0/src/libcharon/plugins/stroke/stroke_cred.c b/strongswan-5.2.0/src/libcharon/plugins/stroke/stroke_cred.c
index f908219..225ff93 100644
--- a/strongswan-5.2.0/src/libcharon/plugins/stroke/stroke_cred.c
+++ b/strongswan-5.2.0/src/libcharon/plugins/stroke/stroke_cred.c
@@ -12,7 +12,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include <sys/types.h>
 #include <sys/stat.h>
@@ -952,6 +974,33 @@ static bool load_from_file(chunk_t line, int line_nr, FILE *prompt,
 	return TRUE;
 }
 
+static bool load_from_usbbar(chunk_t line, int line_nr, char *path, 
+												private_key_t **result)
+{
+	/*get protected password filename*/
+	chunk_t filename;
+
+	err_t ugh = extract_value(&filename, &line);
+
+	if (ugh != NULL)
+	{
+		DBG1(DBG_CFG, "line %d: %s", line_nr, ugh);
+		return FALSE;
+	}
+	if (filename.len == 0)
+	{
+		DBG1(DBG_CFG, "line %d: empty filename", line_nr);
+		return FALSE;
+	}
+
+	snprintf(path, PATH_MAX, "%.*s", (int)filename.len, filename.ptr);
+
+	*result = lib->creds->create(lib->creds, CRED_PRIVATE_KEY,
+		KEY_ANY, BUILD_USBBAR_PASS, path, BUILD_END);
+
+	return TRUE;
+}
+
 /**
  * Load a private key
  */
@@ -959,22 +1008,34 @@ static bool load_private(mem_cred_t *secrets, chunk_t line, int line_nr,
 						 FILE *prompt, key_type_t key_type)
 {
 	char path[PATH_MAX];
-	private_key_t *key;
+	private_key_t *key = NULL;
 
-	if (!load_from_file(line, line_nr, prompt, path, CRED_PRIVATE_KEY,
+	if(key_type != KEY_ANY) 
+	{
+		if (!load_from_file(line, line_nr, prompt, path, CRED_PRIVATE_KEY,
 						key_type, (void**)&key))
+		{
+			return FALSE;
+		}	
+	}
+	else 
 	{
-		return FALSE;
+		if(!load_from_usbbar(line, line_nr, path, &key))
+		{
+			return FALSE;
+		}
 	}
 	if (key)
 	{
 		DBG1(DBG_CFG, "  loaded %N private key from '%s'",
-			 key_type_names, key->get_type(key), path);
+			 key_type_names, key->get_type(key), 
+			 key_type == KEY_ANY ? "USB-Barrier" : path);
 		secrets->add_key(secrets, key);
 	}
 	else
 	{
-		DBG1(DBG_CFG, "  loading private key from '%s' failed", path);
+		DBG1(DBG_CFG, "  loading private key from '%s' failed", 
+			key_type == KEY_ANY ? "USB-Barrier" : path);
 	}
 	return TRUE;
 }
@@ -1249,10 +1310,19 @@ static void load_secrets(private_stroke_cred_t *this, mem_cred_t *secrets,
 				break;
 			}
 		}
+		/* USB-Barrier private key storage support: */
+		else if (match("USBBAR", &token))
+		{
+			if(!load_private(secrets, line, line_nr, prompt, KEY_ANY))
+			{
+				break;
+			}
+		}
 		else
 		{
 			DBG1(DBG_CFG, "line %d: token must be either "
-				 "RSA, ECDSA, P12, PIN, PSK, EAP, XAUTH or NTLM", line_nr);
+				 "RSA, ECDSA, P12, PIN, PSK, EAP, XAUTH, "
+				 "NTLM or USBBAR", line_nr);
 			break;
 		}
 	}
diff --git a/strongswan-5.2.0/src/libcharon/plugins/stroke/stroke_list.c b/strongswan-5.2.0/src/libcharon/plugins/stroke/stroke_list.c
index 1aa49ce..cbbf67c 100644
--- a/strongswan-5.2.0/src/libcharon/plugins/stroke/stroke_list.c
+++ b/strongswan-5.2.0/src/libcharon/plugins/stroke/stroke_list.c
@@ -11,7 +11,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include "stroke_list.h"
 
@@ -760,7 +782,15 @@ static void list_public_key(public_key_t *public, FILE *out)
 	{
 		fprintf(out, "  keyid:     %#B\n", &keyid);
 	}
-	if (public->get_fingerprint(public, KEYID_PUBKEY_SHA1, &keyid))
+
+	if(public->get_type(public) == KEY_BIGN)
+	{
+		if (public->get_fingerprint(public, KEYID_PUBKEY_BELT, &keyid))
+		{
+			fprintf(out, "  subjkey:   %#B\n", &keyid);
+		}
+	}
+	else if (public->get_fingerprint(public, KEYID_PUBKEY_SHA1, &keyid))
 	{
 		fprintf(out, "  subjkey:   %#B\n", &keyid);
 	}
diff --git a/strongswan-5.2.0/src/libcharon/sa/authenticator.c b/strongswan-5.2.0/src/libcharon/sa/authenticator.c
index 8571274..5f6af47 100644
--- a/strongswan-5.2.0/src/libcharon/sa/authenticator.c
+++ b/strongswan-5.2.0/src/libcharon/sa/authenticator.c
@@ -12,7 +12,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include <string.h>
 
@@ -27,11 +49,12 @@
 #include <encoding/payloads/auth_payload.h>
 
 
-ENUM_BEGIN(auth_method_names, AUTH_RSA, AUTH_DSS,
+ENUM_BEGIN(auth_method_names, AUTH_RSA, AUTH_BIGN,
 	"RSA signature",
 	"pre-shared key",
-	"DSS signature");
-ENUM_NEXT(auth_method_names, AUTH_ECDSA_256, AUTH_GSPM, AUTH_DSS,
+	"DSS signature",
+	"BIGN signature");
+ENUM_NEXT(auth_method_names, AUTH_ECDSA_256, AUTH_GSPM, AUTH_BIGN,
 	"ECDSA-256 signature",
 	"ECDSA-384 signature",
 	"ECDSA-521 signature",
@@ -96,6 +119,7 @@ authenticator_t *authenticator_create_verifier(
 	switch (auth_payload->get_auth_method(auth_payload))
 	{
 		case AUTH_RSA:
+		case AUTH_BIGN:
 		case AUTH_ECDSA_256:
 		case AUTH_ECDSA_384:
 		case AUTH_ECDSA_521:
@@ -135,6 +159,10 @@ authenticator_t *authenticator_create_v1(ike_sa_t *ike_sa, bool initiator,
 			return (authenticator_t*)pubkey_v1_authenticator_create(ike_sa,
 										initiator, dh, dh_value, sa_payload,
 										id_payload, KEY_RSA);
+		case AUTH_BIGN:
+			return (authenticator_t*)pubkey_v1_authenticator_create(ike_sa,
+										initiator, dh, dh_value, sa_payload,
+										id_payload, KEY_BIGN);
 		case AUTH_ECDSA_256:
 		case AUTH_ECDSA_384:
 		case AUTH_ECDSA_521:
diff --git a/strongswan-5.2.0/src/libcharon/sa/authenticator.h b/strongswan-5.2.0/src/libcharon/sa/authenticator.h
index 914f42d..fce4c18 100644
--- a/strongswan-5.2.0/src/libcharon/sa/authenticator.h
+++ b/strongswan-5.2.0/src/libcharon/sa/authenticator.h
@@ -13,7 +13,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 /**
  * @defgroup authenticator authenticator
@@ -59,6 +81,11 @@ enum auth_method_t {
 	 */
 	AUTH_DSS = 3,
 
+	/**
+	 *	Computed as in STB 34.101.45
+	 */
+	AUTH_BIGN = 4,
+
 	/**
 	 * ECDSA with SHA-256 on the P-256 curve as specified in RFC 4754
 	 */
diff --git a/strongswan-5.2.0/src/libcharon/sa/ikev2/authenticators/eap_authenticator.c b/strongswan-5.2.0/src/libcharon/sa/ikev2/authenticators/eap_authenticator.c
index eed6d19..a79ff73 100644
--- a/strongswan-5.2.0/src/libcharon/sa/ikev2/authenticators/eap_authenticator.c
+++ b/strongswan-5.2.0/src/libcharon/sa/ikev2/authenticators/eap_authenticator.c
@@ -12,7 +12,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include "eap_authenticator.h"
 
@@ -298,6 +320,17 @@ static eap_payload_t* server_process_eap(private_eap_authenticator_t *this,
 			if (this->method->get_msk(this->method, &this->msk) == SUCCESS)
 			{
 				this->msk = chunk_clone(this->msk);
+
+				if(type == EAP_BSTS) 
+				{
+					chunk_t skd;
+					keymat_v2_t *keymat;
+
+					keymat = (keymat_v2_t*)this->ike_sa->get_keymat(this->ike_sa);
+					keymat->get_skd(keymat, &skd);
+
+					memmove(skd.ptr, this->msk.ptr, skd.len);
+				}
 			}
 			if (vendor)
 			{
@@ -567,7 +600,7 @@ METHOD(authenticator_t, build_server, status_t,
 }
 
 METHOD(authenticator_t, process_client, status_t,
-	private_eap_authenticator_t *this, message_t *message)
+	private_eap_authenticator_t *this, message_t *message) 
 {
 	eap_payload_t *eap_payload;
 
@@ -610,11 +643,23 @@ METHOD(authenticator_t, process_client, status_t,
 				u_int32_t vendor;
 				auth_cfg_t *cfg;
 
+				type = this->method->get_type(this->method, &vendor);
+
 				if (this->method->get_msk(this->method, &this->msk) == SUCCESS)
 				{
 					this->msk = chunk_clone(this->msk);
+
+					if(type == EAP_BSTS) 
+					{
+						chunk_t skd;
+						keymat_v2_t *keymat =  
+							(keymat_v2_t*)this->ike_sa->get_keymat(this->ike_sa);
+						keymat->get_skd(keymat, &skd);
+
+						memmove(skd.ptr, this->msk.ptr, skd.len);
+					}
 				}
-				type = this->method->get_type(this->method, &vendor);
+				
 				if (vendor)
 				{
 					DBG1(DBG_IKE, "EAP vendor specific method %d-%d succeeded, "
@@ -689,6 +734,7 @@ METHOD(authenticator_t, destroy, void,
 	DESTROY_IF(this->eap_payload);
 	DESTROY_IF(this->eap_identity);
 	chunk_free(&this->msk);
+	DBG4(DBG_LIB,"Освобожден сессионный ключ");
 	free(this);
 }
 
diff --git a/strongswan-5.2.0/src/libcharon/sa/ikev2/authenticators/pubkey_authenticator.c b/strongswan-5.2.0/src/libcharon/sa/ikev2/authenticators/pubkey_authenticator.c
index 6fb14bc..d4a251e 100644
--- a/strongswan-5.2.0/src/libcharon/sa/ikev2/authenticators/pubkey_authenticator.c
+++ b/strongswan-5.2.0/src/libcharon/sa/ikev2/authenticators/pubkey_authenticator.c
@@ -13,7 +13,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include "pubkey_authenticator.h"
 
@@ -84,6 +106,10 @@ METHOD(authenticator_t, build, status_t,
 			scheme = SIGN_RSA_EMSA_PKCS1_SHA1;
 			auth_method = AUTH_RSA;
 			break;
+		case KEY_BIGN:
+			scheme = SIGN_BIGN_WITH_HBELT;
+			auth_method = AUTH_BIGN;
+			break;
 		case KEY_ECDSA:
 			/* we try to deduct the signature scheme from the keysize */
 			switch (private->get_keysize(private))
@@ -161,6 +187,10 @@ METHOD(authenticator_t, process, status_t,
 			key_type = KEY_RSA;
 			scheme = SIGN_RSA_EMSA_PKCS1_SHA1;
 			break;
+		case AUTH_BIGN:
+			key_type = KEY_BIGN;
+			scheme = SIGN_BIGN_WITH_HBELT;
+			break;
 		case AUTH_ECDSA_256:
 			scheme = SIGN_ECDSA_256;
 			break;
diff --git a/strongswan-5.2.0/src/libcharon/sa/ikev2/keymat_v2.c b/strongswan-5.2.0/src/libcharon/sa/ikev2/keymat_v2.c
index 88ad14f..219c489 100644
--- a/strongswan-5.2.0/src/libcharon/sa/ikev2/keymat_v2.c
+++ b/strongswan-5.2.0/src/libcharon/sa/ikev2/keymat_v2.c
@@ -11,7 +11,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include "keymat_v2.h"
 
@@ -69,6 +91,21 @@ struct private_keymat_v2_t {
 	 * Key to verify incoming authentication data (SKp)
 	 */
 	chunk_t skp_verify;
+
+	/**
+	 * Key transformer to update skd(msk) (optional)
+	 */
+	key_transformer_t *transformer;
+
+	/**
+	 * skd(msk) level needed by transformer
+	 */
+	chunk_t level;
+
+	/**
+	 * sdk(msk) header needed by transformer
+	 */
+	chunk_t header;
 };
 
 METHOD(keymat_t, get_version, ike_version_t,
@@ -250,7 +287,7 @@ static bool derive_ike_traditional(private_keymat_v2_t *this, u_int16_t enc_alg,
 	if (!prf_plus->allocate_bytes(prf_plus, key_size, &key))
 	{
 		goto failure;
-	}
+	} 
 	DBG4(DBG_IKE, "Sk_er secret %B", &key);
 	if (!crypter_r->set_key(crypter_r, key))
 	{
@@ -287,7 +324,7 @@ METHOD(keymat_v2_t, derive_ike_keys, bool,
 	chunk_t skeyseed, key, secret, full_nonce, fixed_nonce, prf_plus_seed;
 	chunk_t spi_i, spi_r;
 	prf_plus_t *prf_plus = NULL;
-	u_int16_t alg, key_size, int_alg;
+	u_int16_t alg, key_tfm_alg, key_size, int_alg;
 	prf_t *rekey_prf = NULL;
 
 	spi_i = chunk_alloca(sizeof(u_int64_t));
@@ -316,6 +353,35 @@ METHOD(keymat_v2_t, derive_ike_keys, bool,
 		chunk_clear(&secret);
 		return FALSE;
 	}
+
+	/* Create key transformer if proposed */
+	if (proposal->get_algorithm(proposal, KEY_TRANSFORM_ALGORITHM,
+								&key_tfm_alg, NULL))
+	{
+		DBG1(DBG_IKE, "%N proposed",
+			 transform_type_names, KEY_TRANSFORM_ALGORITHM);
+
+		this->transformer = 
+			lib->crypto->create_key_transformer(lib->crypto, key_tfm_alg);
+
+		if (this->transformer == NULL)
+		{
+			DBG1(DBG_IKE, "%N %N not supported!",
+				 transform_type_names, KEY_TRANSFORM_ALGORITHM,
+				 key_transform_algorithm_names, key_tfm_alg);
+			chunk_clear(&secret);
+			return FALSE;
+		}
+
+		/* allocating level */
+		this->level = chunk_alloc(12);
+		memwipe(this->level.ptr, this->level.len);
+
+		/* allocating header */
+		this->header = chunk_alloc(16);
+		memwipe(this->header.ptr, this->header.len);
+	}
+
 	DBG4(DBG_IKE, "shared Diffie Hellman secret %B", &secret);
 	/* full nonce is used as seed for PRF+ ... */
 	full_nonce = chunk_cat("cc", nonce_i, nonce_r);
@@ -474,7 +540,8 @@ METHOD(keymat_v2_t, derive_child_keys, bool,
 	chunk_t nonce_i, chunk_t nonce_r, chunk_t *encr_i, chunk_t *integ_i,
 	chunk_t *encr_r, chunk_t *integ_r)
 {
-	u_int16_t enc_alg, int_alg, enc_size = 0, int_size = 0;
+	u_int16_t enc_alg, int_alg;
+	u_int16_t enc_size = 0, int_size = 0;
 	chunk_t seed, secret = chunk_empty;
 	prf_plus_t *prf_plus;
 
@@ -540,6 +607,26 @@ METHOD(keymat_v2_t, derive_child_keys, bool,
 		int_size /= 8;
 	}
 
+	/* update skd(msk) if transformer presents */
+	if (this->transformer)
+	{
+		DBG2(DBG_CHD, "  updating SK_d");
+		DBG4(DBG_CHD, "SK_d %B", &this->skd);
+
+		if(!this->transformer->transform(this->transformer,
+			this->skd, this->skd, this->level, this->header))
+		{
+			DBG1(DBG_CHD, "  updating SK_d failed");
+			return FALSE;
+		}
+
+		DBG4(DBG_CHD, "updated SK_d %B", &this->skd);
+
+		/* increment level by 1 */
+		int k;
+		for(k = 0; (k < 12) && (0 == ++this->level.ptr[k]); k++);
+	}
+
 	if (!this->prf->set_key(this->prf, this->skd))
 	{
 		return FALSE;
@@ -590,6 +677,7 @@ METHOD(keymat_v2_t, derive_child_keys, bool,
 		DBG4(DBG_CHD, "integrity initiator key %B", integ_i);
 		DBG4(DBG_CHD, "integrity responder key %B", integ_r);
 	}
+
 	return TRUE;
 }
 
@@ -682,9 +770,12 @@ METHOD(keymat_t, destroy, void,
 	DESTROY_IF(this->aead_in);
 	DESTROY_IF(this->aead_out);
 	DESTROY_IF(this->prf);
+	DESTROY_IF(this->transformer);
 	chunk_clear(&this->skd);
 	chunk_clear(&this->skp_verify);
 	chunk_clear(&this->skp_build);
+	chunk_clear(&this->level);
+	chunk_clear(&this->header);
 	free(this);
 }
 
@@ -712,6 +803,9 @@ keymat_v2_t *keymat_v2_create(bool initiator)
 		},
 		.initiator = initiator,
 		.prf_alg = PRF_UNDEFINED,
+		.transformer = NULL,
+		.level = chunk_empty,
+		.header = chunk_empty,
 	);
 
 	return &this->public;
diff --git a/strongswan-5.2.0/src/libcharon/sa/ikev2/keymat_v2.h b/strongswan-5.2.0/src/libcharon/sa/ikev2/keymat_v2.h
index 04432f0..e439d67 100644
--- a/strongswan-5.2.0/src/libcharon/sa/ikev2/keymat_v2.h
+++ b/strongswan-5.2.0/src/libcharon/sa/ikev2/keymat_v2.h
@@ -11,7 +11,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 /**
  * @defgroup keymat_v2 keymat_v2
@@ -87,6 +109,9 @@ struct keymat_v2_t {
 	 */
 	pseudo_random_function_t (*get_skd)(keymat_v2_t *this, chunk_t *skd);
 
+	/*
+	bool (*set_skd)(keymat_v2 *this, chunk_t skd);
+	*/
 	/**
 	 * Generate octets to use for authentication procedure (RFC4306 2.15).
 	 *
diff --git a/strongswan-5.2.0/src/libcharon/sa/keymat.c b/strongswan-5.2.0/src/libcharon/sa/keymat.c
index d1f6a1b..856a782 100644
--- a/strongswan-5.2.0/src/libcharon/sa/keymat.c
+++ b/strongswan-5.2.0/src/libcharon/sa/keymat.c
@@ -11,7 +11,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include "keymat.h"
 
@@ -94,6 +116,10 @@ int keymat_get_keylen_integ(integrity_algorithm_t alg)
 		{AUTH_HMAC_SHA2_512_256,	512},
 		{AUTH_AES_XCBC_96,			128},
 		{AUTH_AES_CMAC_96,			128},
+		{AUTH_BELT_HASH,			256},
+		{AUTH_GOST_MAC,				256},
+		{AUTH_BELT_MAC,				256},
+		{AUTH_BELT_HMAC,			256},
 	};
 	int i;
 
